=== debian/changelog ===
boxes (2.2.1-1) unstable; urgency=medium

  * New upstream version 2.2.1 (Closes: #1054625)
  * Refresh "Change default config path for Debian"
  * Update copyright years for upstream files
  * Declare compliance with Debian policy 4.6.2
  * Update copyright years for debian/* packaging files

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 29 Oct 2023 17:58:10 +0100
