## boxes 2.3.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # boxes - Command line filter to draw/remove ASCII boxes around text
-# Copyright (c) 1999-2023 Thomas Jensen and the boxes contributors
+# Copyright (c) 1999-2024 Thomas Jensen and the boxes contributors
 #
 # This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
 # License, version 3, as published by the Free Software Foundation.
@@ -16,40 +16,75 @@
 # The following line (GLOBALCONF) is the only line you should need to edit!
 GLOBALCONF = /usr/share/boxes
 GIT_STATUS = $(shell git describe --dirty --always 2>/dev/null || echo "n/a")
-BVERSION   = 2.2.1
+BVERSION   = 2.3.1
 
 ALL_FILES  = LICENSE README.md boxes-config
 DOC_FILES  = doc/boxes.1 doc/boxes.el
 PKG_NAME   = boxes-$(BVERSION)
 OUT_DIR    = out
 
+# Set some defaults for BX_LEX and BX_YACC but allow env variables to override them.
+BX_LEX  ?= flex
+BX_YACC ?= bison
+
 PCRE2_VERSION          = 10.40
 PCRE2_DIR              = vendor/pcre2-$(PCRE2_VERSION)
 LIBUNISTRING_VERSION   = 1.0
 LIBUNISTRING_DIR       = vendor/libunistring-$(LIBUNISTRING_VERSION)
+LIBNCURSES_VERSION     = 6.4
+LIBNCURSES_DIR         = vendor/ncurses-$(LIBNCURSES_VERSION)
+LIBNCURSES_WIN_INCLUDE = /c/MinGW/include/ncurses
 WIN_FLEX_BISON_VERSION = 2.5.24
 WIN_FLEX_BISON_DIR     = vendor/flex_bison_$(WIN_FLEX_BISON_VERSION)
 WIN_CMOCKA_VERSION     = 1.1.0
 WIN_CMOCKA_DIR         = vendor/cmocka-$(WIN_CMOCKA_VERSION)
 
-.PHONY: clean build cov win32 debug win32.debug win32.pcre infomsg replaceinfos test covtest \
+.PHONY: clean cleanall build cov win32 debug win32.debug win32.pcre infomsg replaceinfos test covtest \
         package win32.package package_common utest win32.utest static
 
 
+define TERMINFO_SCRIPT
+#!/usr/bin/env bash
+
+# Script to determine a value for TERMINFO and echo it on stdout
+
+declare -r TERMINFO_FALLBACK=/mnt/c/MinGW/lib/terminfo
+
+if [[ -n $${TERMINFO} && -d $${TERMINFO}/78 ]]; then
+    echo "Modern terminfo database found." >&2
+    echo $${TERMINFO}
+else
+    echo "WARNING: Terminfo database not found or outdated." >&2
+    if [[ -d $${TERMINFO_FALLBACK}/78 ]]; then
+        echo "Using $${TERMINFO_FALLBACK} as fallback." >&2
+        echo $${TERMINFO_FALLBACK}
+    else
+        echo "ERROR: Fallback unavailable. " >&2
+        echo -n "Find a terminfo database that uses a hashed structure " >&2
+        echo "(hexadecimal numbers as directories, not single letters). " >&2
+        echo "Set its path in the TERMINFO_FALLBACK variable near the top of the root Makefile." >&2
+        exit 1
+    fi
+fi
+endef
+
+
 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 #    Build
 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 build cov debug: infomsg replaceinfos
-	$(MAKE) -C src BOXES_PLATFORM=unix LEX=flex YACC=bison $@
+	$(MAKE) -C src BOXES_PLATFORM=unix LEX=$(BX_LEX) YACC=$(BX_YACC) $@
 
 win32: infomsg replaceinfos
 	$(MAKE) -C src BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(PCRE2_DIR)/src LDFLAGS=-L../$(PCRE2_DIR)/.libs \
-	    LEX=../$(WIN_FLEX_BISON_DIR)/win_flex.exe YACC=../$(WIN_FLEX_BISON_DIR)/win_bison.exe build
+	    LEX=../$(WIN_FLEX_BISON_DIR)/win_flex.exe YACC=../$(WIN_FLEX_BISON_DIR)/win_bison.exe \
+	    LIBNCURSES_WIN_INCLUDE=$(LIBNCURSES_WIN_INCLUDE) build
 
 win32.debug: infomsg replaceinfos
 	$(MAKE) -C src BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(PCRE2_DIR)/src LDFLAGS=-L../$(PCRE2_DIR)/.libs \
-	    LEX=../$(WIN_FLEX_BISON_DIR)/win_flex.exe YACC=../$(WIN_FLEX_BISON_DIR)/win_bison.exe debug
+	    LEX=../$(WIN_FLEX_BISON_DIR)/win_flex.exe YACC=../$(WIN_FLEX_BISON_DIR)/win_bison.exe \
+	    LIBNCURSES_WIN_INCLUDE=$(LIBNCURSES_WIN_INCLUDE) debug
 
 win32.prereq: $(PCRE2_DIR)/.libs/libpcre2-32.a vendor/win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip \
               vendor/cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip
@@ -111,8 +146,23 @@
 	tar -C vendor -xzf vendor/libunistring-$(LIBUNISTRING_VERSION).tar.gz
 	cd $(LIBUNISTRING_DIR) ; ./configure --enable-static ; $(MAKE)
 
-static: infomsg replaceinfos $(LIBUNISTRING_DIR)/lib/.libs/libunistring.a $(PCRE2_DIR)/.libs/libpcre2-32.a
-	$(MAKE) -C src BOXES_PLATFORM=static LEX=flex YACC=bison LIBUNISTRING_DIR=$(LIBUNISTRING_DIR) PCRE2_DIR=$(PCRE2_DIR) $@
+vendor/libncurses-$(LIBNCURSES_VERSION).tar.gz: | vendor
+	curl -L https://invisible-mirror.net/archives/ncurses/ncurses-$(LIBNCURSES_VERSION).tar.gz --output $@
+
+$(LIBNCURSES_DIR)/lib/libncurses.a: vendor/libncurses-$(LIBNCURSES_VERSION).tar.gz
+	@echo TERMINFO=${TERMINFO}
+	tar -C vendor -xzf vendor/libncurses-$(LIBNCURSES_VERSION).tar.gz
+	cd $(LIBNCURSES_DIR) ; ./configure --enable-static --enable-termcap; $(MAKE)
+
+export TERMINFO_SCRIPT
+$(OUT_DIR)/terminfo-check.sh: | $(OUT_DIR)
+	echo "$$TERMINFO_SCRIPT" > $@ 
+
+static: infomsg replaceinfos $(LIBUNISTRING_DIR)/lib/.libs/libunistring.a $(PCRE2_DIR)/.libs/libpcre2-32.a $(OUT_DIR)/terminfo-check.sh
+	TERMINFO=`$(OUT_DIR)/terminfo-check.sh` \
+	    $(MAKE) LIBNCURSES_DIR=$(LIBNCURSES_DIR) LIBNCURSES_VERSION=$(LIBNCURSES_VERSION) $(LIBNCURSES_DIR)/lib/libncurses.a
+	$(MAKE) -C src BOXES_PLATFORM=static LEX=$(BX_LEX) YACC=$(BX_YACC) LIBUNISTRING_DIR=$(LIBUNISTRING_DIR) \
+        PCRE2_DIR=$(PCRE2_DIR) LIBNCURSES_DIR=$(LIBNCURSES_DIR) LIBNCURSES_WIN_INCLUDE=$(LIBNCURSES_WIN_INCLUDE) $@
 
 
 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
@@ -131,7 +181,7 @@
 $(OUT_DIR)/zip/$(PKG_NAME).zip:
 	mkdir -p $(OUT_DIR)/zip/$(PKG_NAME)
 	unix2dos -n LICENSE $(OUT_DIR)/zip/$(PKG_NAME)/LICENSE.txt
-	unix2dos -n boxes-config $(OUT_DIR)/zip/$(PKG_NAME)/boxes.cfg
+	unix2dos -n --force boxes-config $(OUT_DIR)/zip/$(PKG_NAME)/boxes.cfg
 	unix2dos -n README.md $(OUT_DIR)/zip/$(PKG_NAME)/README.md
 	unix2dos -n README.Win32.md $(OUT_DIR)/zip/$(PKG_NAME)/README.Win32.md
 	unix2dos -n doc/boxes.1 $(OUT_DIR)/zip/$(PKG_NAME)/boxes.1
@@ -157,7 +207,7 @@
 	unix2dos -n LICENSE tools/LICENSE.txt
 
 tools/boxes.cfg: boxes-config
-	unix2dos -n boxes-config tools/boxes.cfg
+	unix2dos -n --force boxes-config tools/boxes.cfg
 
 tools/boxes.exe: $(OUT_DIR)/boxes.exe
 	cp $(OUT_DIR)/boxes.exe tools/
@@ -183,15 +233,21 @@
 	$(MAKE) -C utest BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(PCRE2_DIR)/src:../$(WIN_CMOCKA_DIR)/include \
 	    LDFLAGS_ADDTL="-L../$(PCRE2_DIR)/.libs -L../$(WIN_CMOCKA_DIR)/lib" utest
 
+test-sunny:
+	cd test; ./test-sunny-days-all.sh
+
+covtest-sunny:
+	cd test; ./test-sunny-days-all.sh --coverage
+
+
 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 #    Cleanup
 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 clean:
-	rm -f $(OUT_DIR)/boxes.h tools/boxes.cfg tools/LICENSE.txt tools/boxes.exe tools/README*.md boxes.portable.*.nupkg
+	rm -f tools/boxes.cfg tools/LICENSE.txt tools/boxes.exe tools/README*.md boxes.portable.*.nupkg
 	rm -f doc/boxes.1 doc/boxes.1.raw.html doc/boxes.1.html
+	$(MAKE) -C src clean
+
+cleanall: clean
 	rm -rf vendor
-	$(MAKE) -C src clean
-
-
-#EOF
