=== utest/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # boxes - Command line filter to draw/remove ASCII boxes around text
-# Copyright (c) 1999-2023 Thomas Jensen and the boxes contributors
+# Copyright (c) 1999-2024 Thomas Jensen and the boxes contributors
 #
 # This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
 # License, version 3, as published by the Free Software Foundation.
@@ -19,8 +19,8 @@
 UTEST_DIR  = ../utest
 VPATH      = $(SRC_DIR):$(SRC_DIR)/misc:$(UTEST_DIR)
 
-UTEST_NORM = global_mock.c cmdline_test.c tools_test.c regulex_test.o main.o
-MOCKS = bx_fprintf
+UTEST_NORM = global_mock.c bxstring_test.o cmdline_test.c logging_test.c tools_test.c regulex_test.o remove_test.o \
+             main.o unicode_test.o utest_tools.o
 
 .PHONY: check_dir flags_unix flags_win32 flags_ utest
 
@@ -36,14 +36,14 @@
 	mkdir $(OUT_DIR)
 
 flags_unix:
-	$(eval CFLAGS := -I. -I$(SRC_DIR) -O -Wall -W $(CFLAGS_ADDTL))
-	$(eval LDFLAGS := $(LDFLAGS) $(foreach MOCK,$(MOCKS),-Wl,--wrap=$(MOCK)) --coverage $(LDFLAGS_ADDTL))
+	$(eval CFLAGS := -I. -I$(SRC_DIR) -O -Wall -W -Wno-stringop-overflow $(CFLAGS_ADDTL))
+	$(eval LDFLAGS := $(LDFLAGS) --coverage $(LDFLAGS_ADDTL))
 	$(eval UTEST_EXECUTABLE_NAME := unittest)
 	$(eval UTEST_OBJ := $(UTEST_NORM:.c=.o))
 
 flags_win32:
 	$(eval CFLAGS := -Os -s -std=c99 -m32 -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
-	$(eval LDFLAGS := $(LDFLAGS) -s -std=c99 -m32 $(foreach MOCK,$(MOCKS),-Wl,--wrap=$(MOCK)) $(LDFLAGS_ADDTL))
+	$(eval LDFLAGS := $(LDFLAGS) -s -std=c99 -m32 $(LDFLAGS_ADDTL))
 	$(eval UTEST_EXECUTABLE_NAME := unittest.exe)
 	$(eval UTEST_OBJ := $(UTEST_NORM:.c=.o))
 
@@ -66,8 +66,13 @@
 	    -lkernel32 -l:libunistring.a -l:libpcre2-32.a -l:libiconv.a -l:libcmocka.dll.a
 
 
-global_mock.o:  global_mock.c global_mock.h boxes.h unicode.h config.h | check_dir
-cmdline_test.o: cmdline_test.c cmdline_test.h global_mock.h boxes.h cmdline.h config.h | check_dir
-tools_test.o:   tools_test.c tools_test.h tools.h config.h | check_dir
-regulex_test.o: regulex_test.c regulex_test.h global_mock.h regulex.h config.h | check_dir
-main.o:         main.c global_mock.h tools_test.h regulex_test.h config.h | check_dir
+global_mock.o:   global_mock.c global_mock.h boxes.h unicode.h tools.h config.h | check_dir
+bxstring_test.o: bxstring_test.c bxstring_test.h boxes.h bxstring.h global_mock.h tools.h unicode.h utest_tools.h config.h | check_dir
+cmdline_test.o:  cmdline_test.c cmdline_test.h boxes.h cmdline.h global_mock.h tools.h config.h | check_dir
+logging_test.o:  logging_test.c logging_test.h boxes.h global_mock.h logging.h tools.h config.h | check_dir
+tools_test.o:    tools_test.c tools_test.h tools.h unicode.h config.h | check_dir
+regulex_test.o:  regulex_test.c regulex_test.h boxes.h global_mock.h regulex.h config.h | check_dir
+remove_test.o:   remove_test.c remove_test.h boxes.h remove.h shape.h tools.h unicode.h global_mock.h utest_tools.h config.h | check_dir
+main.o:          main.c bxstring_test.h cmdline_test.h global_mock.h tools_test.h regulex_test.h unicode_test.h config.h | check_dir
+unicode_test.o:  unicode_test.c unicode_test.h boxes.h tools.h unicode.h config.h | check_dir
+utest_tools.o:   utest_tools.c utest_tools.h config.h | check_dir
