=== debian/changelog ===
boxes (2.3.1-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 23 Jan 2025 07:32:49 +0100

boxes (2.3.1-1~exp3) experimental; urgency=medium

  * Fix failing test 150_tag_config_invalid_tags on big-endian systems
  * Update copyright years for debian/* packaging files

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 22 Jan 2025 22:51:44 +0100

boxes (2.3.1-1~exp2) experimental; urgency=medium

  * debian/patches: Remove some upstream failing tests

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 23 Nov 2024 22:11:30 +0100

boxes (2.3.1-1~exp1) experimental; urgency=medium

  * New upstream version 2.3.1
  * Refresh "Change default config path for Debian"
  * debian/copyright: Drop file stanzas for src/misc/getopt.{c,h} files

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 06 Oct 2024 21:03:25 +0200

boxes (2.3.0-1~exp1) experimental; urgency=medium

  * New upstream version 2.3.0
  * debian/sala-ci.yml: Disable gbp setup-gitattributes call in pipelines
  * Update copyright years for upstream files
  * Add Build-Depends on libncurses-dev
  * Update copyright years for debian/* packaging files
  * Refresh "Change default config path for Debian"
  * debian/rules: Use C.UTF-8 locale for testsuite
  * d/rules: Explicitly set TERM=xterm-color when running testsuite
  * debian/tests/smoke-test: Force TERM and LC_ALL setups in analogy to
    testsuite
  * Declare compliance with Debian policy 4.7.0

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 10 May 2024 23:14:18 +0200
