=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: text
 Priority: optional
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends:
  bison,
  debhelper-compat (= 13),
  flex,
+ libncurses-dev,
  libpcre2-dev,
  libunistring-dev,
  xxd <!nocheck>
