=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS_ADDTL+=-O $(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- debug

override_dh_auto_test:
	TERM=xterm-color LC_ALL=C.UTF-8 dh_auto_test
